// MyDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ClientSample.h"
#include "MyDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyDialog dialog
extern long          g_nPluginID;
extern SENDREQUEST   g_SendRequest;
extern TRANSMITFILE  g_TransmitFile;

CMyDialog::CMyDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CMyDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_PluginName = "My ClientSide Plug-in";
}


void CMyDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyDialog, CDialog)
	//{{AFX_MSG_MAP(CMyDialog)
	ON_BN_CLICKED(IDC_BTN_SEND, OnBtnSend)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_GETTEXT,OnGetWindowText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyDialog message handlers

void CMyDialog::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	//CDialog::OnCancel();
}

void CMyDialog::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}

void CMyDialog::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::PostNcDestroy();

	delete this;
}

void __stdcall CMyDialog::OnResponse(long nResult,
									 long nUserData,
									 const char *Buf,
									 long nBufLen)
{
     CMyDialog* pDlg = (CMyDialog*)nUserData;
	 
	 char* pData = new char [nBufLen+1];
	 memset(pData,0,nBufLen+1);
     memcpy(pData,Buf,nBufLen);

	 pDlg->SetDlgItemText(IDC_EDIT_RESPONSE,pData);

	 delete [] pData;
}

LRESULT CMyDialog::OnGetWindowText(WPARAM wParam, LPARAM lParam)
{
    int nBytesToCopy = (int)wParam;
	char* pBuf = (char*)lParam;

	strncpy(pBuf,(LPCTSTR)m_PluginName,nBytesToCopy);

	return strlen(pBuf);
}

void CMyDialog::OnBtnSend() 
{
	// TODO: Add your control notification handler code here
	CString sRequest;
	GetDlgItemText(IDC_EDIT_REQUEST,sRequest);

	g_SendRequest(g_nPluginID,
		          (long)this,
				  "ServerSample.dll",
				  (LPCTSTR)sRequest,
				  sRequest.GetLength(),
				  OnResponse);
}
