// ServerSample.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "RAdmPlugin.h"

extern "C"
{

    __declspec(dllexport) void Initialize(long* major,long* minor);
	__declspec(dllexport) bool ProcessMsg(PLUGIN_MESSAGE* msg);
	__declspec(dllexport) void UnloadPlugIn();

};


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

void Initialize(long* major,long* minor)
{
    if(major != NULL && minor != NULL)
	{
        *major = 1;
		*minor = 0;
	}
}

bool ProcessMsg(PLUGIN_MESSAGE* msg)
{
	DWORD  ByteReads = 0;
    HANDLE hFile = (HANDLE)msg->StgHandle;
	long nBufSize = GetFileSize(hFile,0);
	if(nBufSize == 0)
		return false;
	char* pszCmd = new char [nBufSize + 1];
	memset(pszCmd,0,nBufSize + 1);
	bool nResult = false;
	if(ReadFile(hFile,pszCmd,nBufSize,&ByteReads,NULL))
	{
        _strlwr(pszCmd);

		char szMsg[256];

		if(strcmp(pszCmd,"gettime") == 0)
		{
            SYSTEMTIME tmNow;
			GetLocalTime(&tmNow);
			sprintf(szMsg,"%d/%d/%d %d:%d:%d",
				    tmNow.wYear,
					tmNow.wMonth,
					tmNow.wDay,
					tmNow.wHour,
					tmNow.wMinute,
					tmNow.wSecond);
		}
		else
		    strcpy(szMsg,"Command not supported");
			
		msg->WriteData(msg->ConnID,
	   	               szMsg,
					   strlen(szMsg),
					   NULL);
	}
	else
		nResult = false;
	
	delete [] pszCmd;

	return nResult;
}

void UnloadPlugIn()
{
     
}