#ifndef __WINCON_H__

#define __WINCON_H__

//#include "WinconSDK.h"
#define WINCONSDK_API extern "C" __declspec(dllimport)
#define FLASH_SEG_128K       0x20000
#define FLASH_SEG_256K       0x40000

WINCONSDK_API void DO_8(int slot, unsigned char cdata);

WINCONSDK_API void DO_16(int slot, unsigned int cdata);

WINCONSDK_API void DO_32(int slot, unsigned long cdata);

WINCONSDK_API unsigned char DI_8(int slot);

WINCONSDK_API unsigned int DI_16(int slot);

WINCONSDK_API unsigned long DI_32(int slot);

WINCONSDK_API void DIO_DO_8(int slot, unsigned char data);

WINCONSDK_API void DIO_DO_16(int slot, unsigned int data);


WINCONSDK_API int GetSystemSerialNumber(char *string1);

WINCONSDK_API int GetNameOfModule(int slot, char *string1);

WINCONSDK_API int GetModuleType(int slot);

WINCONSDK_API DWORD GetSlotAddr(int slot);


WINCONSDK_API DWORD GetTimeTicks(void);

WINCONSDK_API DWORD GetDIOData32(int slot);

WINCONSDK_API void WriteDIOData32(int slot, DWORD dw);


WINCONSDK_API unsigned char IoReadByte(DWORD addr);

WINCONSDK_API void IoWriteByte(DWORD addr, unsigned char cdata);

WINCONSDK_API void ShowLED16(int slot, unsigned int cdata);

WINCONSDK_API void ShowLED32(int slot, unsigned long cdata);

WINCONSDK_API void AutoScan(int flag, unsigned long delay, int caller);


WINCONSDK_API int ProgramMAC(unsigned char *MAC);
WINCONSDK_API int ReadMAC(unsigned char *MAC);

WINCONSDK_API unsigned char ReadEEP(int block, int offset);
WINCONSDK_API void WriteEEP(int block, int offset, unsigned char ucData);


WINCONSDK_API DWORD FlashWriteString(unsigned int segment, DWORD offset, LPBYTE data, DWORD len);
WINCONSDK_API void FlashErase(unsigned int segment);
WINCONSDK_API DWORD GetFlashSize(DWORD* pDwSegmentSize);

WINCONSDK_API void GetOSversion(LPTSTR lpOSversion);
WINCONSDK_API void GetSDKversion(LPTSTR lpSDKversion);

WINCONSDK_API void ChangeSlotTo87K(unsigned char slotNo);

// unsigned int V_DI_16(int slot);

// void V_DO_16(int slot, unsigned int cdata);

//#include <WinCon1.h>

#endif // __WINCON_H__
